;  Start of MATHS

        if enabled UseMacros

Neg_HL          macro()

                ld a,l                          ;
                cpl                             ;
                ld l,a                          ;
                ld a,h                          ;
                cpl                             ;
                ld h,a                          ;
                inc hl                          ;

                endm

Neg_DE          macro()

                ld a,e                          ;
                cpl                             ;
                ld e,a                          ;
                ld a,d                          ;
                cpl                             ;
                ld d,a                          ;
                inc de                          ;

                endm

        else

Neg_HL          macro()
                call DoNegHL
                mend

DoNegHL         ld a,l                          ;
                cpl                             ;
                ld l,a                          ;
                ld a,h                          ;
                cpl                             ;
                ld h,a                          ;
                inc hl                          ;
                ret                             ;

Neg_DE          macro()
                call DoNegDE
                mend

DoNegDE         ld a,e                          ;
                cpl                             ;
                ld e,a                          ;
                ld a,d                          ;
                cpl                             ;
                ld d,a                          ;
                inc de                          ;
                ret                             ;
        endif

Rand            push hl                         ;
                push bc                         ;

                call Rand1                      ;

                pop bc                          ;
                pop hl                          ;
                ld de,(Seed)                    ;
                ret                             ;


Rand1           ld hl,(Seed+2)                  ;
                rl l                            ;
                rl h                            ;
                rl l                            ;
                rl h                            ;
                ld c,h                          ;
                ld a,(Seed)                     ;
                rla                             ;
                ld b,a                          ;
                ld de,(Seed+1)                  ;
                rl e                            ;
                rl d                            ;
                res 7,d                         ;
                ld hl,(Seed)                    ;
                add hl,bc                       ;
                ld (Seed),hl                    ;
                ld hl,(Seed+2)                  ;
                adc hl,de                       ;
                res 7,h                         ;
                ld (Seed+2),hl                  ;
                ret m                           ;
                ld hl,Seed                      ;
Rand2           inc (hl)                        ;
                ret nz                          ;
                inc hl                          ;
                jr Rand2                        ;

Seed            defb "Nig!"                     ;

DivHLDE         ld a,h                          ;
                cp d                            ;
                jr z,Div1                       ;
                jr nc,Div16                     ;
Div81           xor a                           ;
Div8            ld c,a                          ;
                add hl,hl                       ;
                sbc hl,de                       ;
                jr c,Div70                      ;
                adc a,a                         ;
                add hl,hl                       ;
                sbc hl,de                       ;
                jr c,Div60                      ;
Div61           adc a,a                         ;
                add hl,hl                       ;
                sbc hl,de                       ;
                jr c,Div50                      ;
Div51           adc a,a                         ;
                add hl,hl                       ;
                sbc hl,de                       ;
                jr c,Div40                      ;
Div41           adc a,a                         ;
                add hl,hl                       ;
                sbc hl,de                       ;
                jr c,Div30                      ;
Div31           adc a,a                         ;
                add hl,hl                       ;
                sbc hl,de                       ;
                jr c,Div20                      ;
Div21           adc a,a                         ;
                add hl,hl                       ;
                sbc hl,de                       ;
                jr c,Div10                      ;
Div11           adc a,a                         ;
                add hl,hl                       ;
                sbc hl,de                       ;
                adc a,a                         ;
                cpl                             ;
                ld l,a                          ;
                ld h,c                          ;
                ret                             ;

Div1            ld a,l                          ;
                cp e                            ;
                jr c,Div81                      ;
                jr z,Div0                       ;
Div16           ld a,l                          ;
                ld l,h                          ;
                ld h,$00                        ;
                ld b,$08                        ;
Div16a          add a,a                         ;
                adc hl,hl                       ;
                sbc hl,de                       ;
                jr nc,Div16b                    ;
                add hl,de                       ;
                djnz Div16a                     ;
                jp Div8                         ;

Div16b          inc a                           ;
                djnz Div16a                     ;
                jp Div8                         ;

Div70           adc a,a                         ;
                add hl,hl                       ;
                add hl,de                       ;
                ccf                             ;
                jr nc,Div61                     ;
Div60           adc a,a                         ;
                add hl,hl                       ;
                add hl,de                       ;
                ccf                             ;
                jr nc,Div51                     ;
Div50           adc a,a                         ;
                add hl,hl                       ;
                add hl,de                       ;
                ccf                             ;
                jr nc,Div41                     ;
Div40           adc a,a                         ;
                add hl,hl                       ;
                add hl,de                       ;
                ccf                             ;
                jr nc,Div31                     ;
Div30           adc a,a                         ;
                add hl,hl                       ;
                add hl,de                       ;
                ccf                             ;
                jr nc,Div21                     ;
Div20           adc a,a                         ;
                add hl,hl                       ;
                add hl,de                       ;
                ccf                             ;
                jr nc,Div11                     ;
Div10           adc a,a                         ;
                add hl,hl                       ;
                add hl,de                       ;
                ccf                             ;
                adc a,a                         ;
                cpl                             ;
                ld l,a                          ;
                ld h,c                          ;
                ret                             ;

Div0            ld hl,$0100                     ;
                ret                             ;

ObjeDiv         bit 7,h                         ;
                jr nz,OD1                       ;
                call DivHLDE                    ;
                srl h                           ;
                rr l                            ;
                ret                             ;

OD1             ld a,l                          ;
                cpl                             ;
                ld l,a                          ;
                ld a,h                          ;
                cpl                             ;
                ld h,a                          ;
                inc hl                          ;
                call DivHLDE                    ;
                ld a,l                          ;
                cpl                             ;
                ld l,a                          ;
                ld a,h                          ;
                cpl                             ;
                ld h,a                          ;
                inc hl                          ;
                sra h                           ;
                rr l                            ;
                ret                             ;

ShapeDiv        push bc                         ;
                call ObjeDiv                    ;
                pop bc                          ;
                ret                             ;

MultHLDE        ld b,h                          ;
                ld c,l                          ;
                ld hl,0                         ;
                ld a,c                          ;
                ld c,b                          ;
                ld b,8                          ;
                rra                             ;
Mul0            jr nc,Mul1                      ;
                add hl,de                       ;
Mul1            rr h                            ;
                rl l                            ;
                rra                             ;
                djnz Mul0                       ;
                ld b,a                          ;
                ld a,c                          ;
                ld c,b                          ;
                ld b,$08                        ;
                rra                             ;
Mul2            jr nc,Mul3                      ;
                add hl,de                       ;
Mul3            rr h                            ;
                rr l                            ;
                rra                             ;
                djnz Mul2                       ;
                ld h,l                          ;
                ld l,a                          ;
                ret                             ;

SignMult        bit 7,h                         ;
                jr z,SM1                        ;
                ld a,h                          ;
                cpl                             ;
                ld h,a                          ;
                ld a,l                          ;
                cpl                             ;
                ld l,a                          ;
                inc hl                          ;
                bit 7,d                         ;
                jr z,SMn                        ;
                ld a,d                          ;
                cpl                             ;
                ld d,a                          ;
                ld a,e                          ;
                cpl                             ;
                ld e,a                          ;
                inc de                          ;
SMp             jp MultHLDE                     ;

SMn             call MultHLDE                   ;
                ld a,h                          ;
                cpl                             ;
                ld h,a                          ;
                ld a,l                          ;
                cpl                             ;
                ld l,a                          ;
                inc hl                          ;
                ret                             ;

SM1             bit 7,d                         ;
                jr z,MultHLDE                   ;
                ld a,d                          ;
                cpl                             ;
                ld d,a                          ;
                ld a,e                          ;
                cpl                             ;
                ld e,a                          ;
                inc de                          ;
                jp SMn                          ;

SignDiv         bit 7,h                         ;
                jr z,SD1                        ;
                ld a,h                          ;
                cpl                             ;
                ld h,a                          ;
                ld a,l                          ;
                cpl                             ;
                ld l,a                          ;
                inc hl                          ;
                bit 7,d                         ;
                jr z,SDn                        ;
                ld a,d                          ;
                cpl                             ;
                ld d,a                          ;
                ld a,e                          ;
                cpl                             ;
                ld e,a                          ;
                inc de                          ;
SDp             jp DivHLDE                      ;

SDn             call DivHLDE                    ;
                ld a,h                          ;
                cpl                             ;
                ld h,a                          ;
                ld a,l                          ;
                cpl                             ;
                ld l,a                          ;
                inc hl                          ;
                ret                             ;

SD1             bit 7,d                         ;
                jp z,DivHLDE                    ;
                ld a,d                          ;
                cpl                             ;
                ld d,a                          ;
                ld a,e                          ;
                cpl                             ;
                ld e,a                          ;
                inc de                          ;
                jp SDn                          ;

;  End of MATHS
